/**
* Copyright (c) 2018 The Nuinalp Authors. All rights reserved.
* Use of this source code is governed by a BSD-style license that can be
* found in the LICENSE file.
*/

@import './utils/_depth';

.button {
  
  //
  // Base Style
  //
  @extend .anim-input;
  background-color: $primary;
  border: 1px solid $primary;
  border-radius: $button-border-radius;
  color: $white;
  font-size: $font-size-base;
  overflow: hidden;
  padding: $padding-base-y $padding-base-x;
  position: relative;
  text-decoration: none;

  &:hover {
    background-color: lighten($primary, 20%);
    
    .fx-hover {
      opacity: 1;
      transform: unset;
      visibility: visible;
      will-change: transform, opacity, visibility;
    }
    
    .fx-click {
      transform: scale(0);
      will-change: transform, opacity, visibility;
    }
  }
  
  // Style for click effect
  
  .fx-click {
    @extend .anim-input;
    background-color: lighten($primary, 15%);
    border-radius: 100%;
    filter: blur(10px);
    height: 0;
    opacity: 0;
    padding-bottom: 90%;
    position: absolute;
    transform: translate(-50%, -50%) scale(0);
    transition-delay: 0s, 0s, 0s;
    transition-duration: 100ms;
    transition-property: opacity, padding-bottom, width;
    width: 90%;
    z-index: 2;

    &.fx-running {
      animation: animFX 0.65s linear;
      opacity: 1;
    }
  }

  .fx-hover {
    @extend .anim-moviment-simple;
    background-color: $primary;
    border-radius: 50%;
    display: block;
    filter: blur(10px);
    height: 0;
    opacity: 0;
    padding-bottom: 90%;
    position: absolute;
    transform: translate(-50%, -50%);
    transition-property: opacity;
    visibility: hidden;
    width: 90%;
    z-index: 1;
  }

  // Disabled style

  &.disabled,
  &:disabled {
    background-color: ligthen($primary, 10%);
    cursor: not-allowed;
  }

  span {
    position: relative;
    z-index: 3;
  }

  // Fix height from buttons
  .badge {
    margin-bottom: -5px;
    margin-top: -5px;
  }

  @each $themeName, $value in $theme-colors {
    
    //
    // Global style with theme colors
    //
    
    // Default
    
    &.#{$themeName} {
      background-color: $value;
      border: 1px solid $value;
      color: $white;

      &:hover {
        background-color: lighten($value, 20%);
      }

      .fx-hover {
        background-color: $value;
      }

      .fx-click {
        background-color: darken($value, 15%);
      }

      span {
        color: $white;
      }

      .fx-hover {
        background-color: $value;
      }

      // Disabled style      
      &.disabled,
      &:disabled {
        background-color: lighten($value, 45%);
        border: 1px solid lighten($value, 45%);
      }
    } 

    // Outline style

    &.#{$themeName}-outline {
      background-color: $white;
      border: 1px solid $value;
      color: $value;

      &:hover,
      &:hover span {
        border-color: lighten($value, 10%);
        color: lighten($value, 10%);
      }
      
      span {
        color: $white;
      }
      
      // Disabled style      
      &.disabled,
      &:disabled {
        border: 1px solid lighten($value, 30%);
        color: lighten($value, 30%);
      }
    }
  }

  // Circle Style
  &.circle {
    border-radius: 100% !important;
    height: 90px;
    padding: $padding-base-y 0 !important;
    width: 90px;
  }

  //
  // Global size styles
  //

  // Small style
  &.small {
    font-size: $font-size-sm;
    padding: $padding-sm-y $padding-sm-x;
  }
  
  // Medium style
  &.medium {
    font-size: $font-size-md;
    padding: $padding-md-y $padding-md-x;
  }
  
  // Large style
  &.large {
    font-size: $font-size-lg;
    padding: $padding-lg-y $padding-lg-x;
  }

  // Extra large style
  &.big {
    font-size: $font-size-big;
    padding: $padding-big-y $padding-big-x;
  }
  
  //
  // Global depth for Buttons follow Nuinalp Language Design
  //

  &.depth {
    @extend .depth-8;
  }

  &.depth-top {
    @extend .depth-8-top;
  }

  &.depth-center {
    @extend .depth-8-center;
  }

  //
  // Animations
  //

  // &.animation {

  // }
}



// Special style for Dialogs
.dialog-footer {
  // Outline style
  .button {
    background-color: $white;
    border: 0 none;
    border-radius: 0 !important;
    color: $dark;
    font-family: 'FiraGo Italic';
    padding-bottom: 20px !important;
    padding-top: 20px !important;

    &:not(:last-child) {
      border-right: 1px solid rgba($dark, 0.1);
    }

    span {
      color: $primary;
    }

    @each $themeName, $value in $theme-colors {
      &.#{$themeName} {    
        color: $value;

        &:hover,
        &:hover span {
          background-color: transparent;
          color: lighten($value, 10%);
        }
        
        span {
          color: $white;
        }
        
        // Disabled style      
        &.disabled,
        &:disabled {
          border: 1px solid lighten($value, 30%);
          color: lighten($value, 30%);
        }
      }
    }
  }
}

// Animation for click effect

@keyframes animFX {
  100% {
    border-radius: 100%;
    opacity: 0;
    transform: scale(3);
  }
}
